#property copyright "Copyright  2008, gpwr"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

extern int Method = 1;
extern int LastBar = 0;
extern int PastBars = 300;
extern double LPOrder = 0.6;
extern int FutBars = 30;
extern int HarmNo = 20;
extern double FreqTOL = 0.0001;
extern int BurgWin = 0;
double g_ibuf_116[];
double g_ibuf_120[];
int gi_148;
int gi_152;
int gi_156;
int gi_160;

int init() {
   MathSrand(TimeLocal());
   return (0);
}

int deinit() {
   ObjectsDeleteAll(0, OBJ_ARROW);
   return (0);
}

int start() {
   int l_global_var_8;
   int l_global_var_12;
   int l_global_var_16;
   double lda_32[];
   double lda_36[];
   double ld_44;
   double ld_52;
   double ld_60;
   double ld_68;
   int li_80;
   double ld_88;
   double ld_96;
   int li_104;
   int li_108;
   int li_unused_112;
   int li_116;
   double ld_120;
   int li_128;
   double ld_132;
   string l_var_name_0 = "exmap.enabled." + Symbol() + Period();
   if (GlobalVariableCheck(l_var_name_0)) {
      l_global_var_8 = GlobalVariableGet(l_var_name_0);
      if (l_global_var_8 == 0) return;
   } else return (0);
   gi_156 = LastBar;
   gi_148 = PastBars;
   gi_160 = LPOrder * PastBars;
   gi_152 = FutBars;
   if (Method > 1) gi_152 = gi_148 - gi_160 - 1;
   if (HarmNo == 0) HarmNo = gi_148;
   if (GlobalVariableCheck("gi0")) {
      l_global_var_12 = GlobalVariableGet("gi0");
      l_global_var_16 = GlobalVariableGet("gip");
      gi_156 = l_global_var_12;
      gi_148 = l_global_var_16 - l_global_var_12;
      gi_160 = LPOrder * gi_148;
   }
   IndicatorBuffers(4);
   SetIndexBuffer(0, g_ibuf_116);
   SetIndexBuffer(1, g_ibuf_120);
   SetIndexShift(0, -gi_156);
   SetIndexShift(1, gi_152 - gi_156);
   IndicatorShortName("Extrapolator");
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_NONE);
   ArrayInitialize(g_ibuf_116, EMPTY_VALUE);
   ArrayInitialize(g_ibuf_120, EMPTY_VALUE);
   double ld_20 = 0.0;
   for (int l_index_28 = 0; l_index_28 < gi_148; l_index_28++) ld_20 += Open[l_index_28 + gi_156];
   ld_20 /= gi_148;
   if (Method == 1) {
      for (l_index_28 = 0; l_index_28 < gi_148; l_index_28++) {
         g_ibuf_116[l_index_28] = ld_20;
         if (l_index_28 <= gi_152) g_ibuf_120[l_index_28] = ld_20;
      }
   } else {
      ArrayResize(lda_32, gi_160 + 1);
      ArrayResize(lda_36, gi_148);
      for (l_index_28 = 0; l_index_28 < gi_148; l_index_28++) lda_36[gi_148 - 1 - l_index_28] = Open[l_index_28 + gi_156] - ld_20;
   }
   switch (Method) {
   case 1:
      for (int l_count_76 = 0; l_count_76 < HarmNo; l_count_76++) {
         Freq(ld_44, ld_52, ld_60, ld_68);
         for (l_index_28 = 0; l_index_28 < gi_148; l_index_28++) {
            g_ibuf_116[l_index_28] += (ld_52 + ld_60 * MathCos(ld_44 * l_index_28) + ld_68 * MathSin(ld_44 * l_index_28));
            if (l_index_28 <= gi_152) g_ibuf_120[l_index_28] += (ld_52 + ld_60 * MathCos(ld_44 * l_index_28) - ld_68 * MathSin(ld_44 * l_index_28));
         }
      }
      break;
   case 2:
      ACF(lda_36, gi_160, lda_32);
      break;
   case 3:
      WBurg(lda_36, gi_160, BurgWin, lda_32);
      break;
   case 4:
      HNBurg(lda_36, gi_160, lda_32);
      break;
   case 5:
      Geom(lda_36, gi_160, lda_32);
      break;
   case 6:
      li_80 = 0;
      MCov(lda_36, gi_160, lda_32, li_80);
      if (li_80 == 1) {
         Print("Terminated prematurely");
         return (0);
      }
      for (l_index_28 = gi_160; l_index_28 >= 1; l_index_28--) lda_32[l_index_28] = lda_32[l_index_28 - 1];
   }
   if (Method > 1) {
      for (int li_84 = gi_160; li_84 < gi_148 + gi_152; li_84++) {
         ld_88 = 0.0;
         for (l_index_28 = 1; l_index_28 <= gi_160; l_index_28++) {
            if (li_84 - l_index_28 < gi_148) ld_88 -= lda_32[l_index_28] * (lda_36[li_84 - l_index_28]);
            else ld_88 -= lda_32[l_index_28] * (g_ibuf_120[li_84 - l_index_28 - gi_148 + 1]);
         }
         if (li_84 < gi_148) g_ibuf_116[gi_148 - 1 - li_84] = ld_88;
         else g_ibuf_120[li_84 - gi_148 + 1] = ld_88;
      }
      g_ibuf_120[0] = g_ibuf_116[0];
      for (l_index_28 = 0; l_index_28 < gi_148 - gi_160; l_index_28++) {
         g_ibuf_116[l_index_28] += ld_20;
         g_ibuf_120[l_index_28] += ld_20;
      }
   }
   for (l_index_28 = 0; l_index_28 <= (gi_152 - 1) / 2; l_index_28++) {
      ld_96 = g_ibuf_120[l_index_28];
      g_ibuf_120[l_index_28] = g_ibuf_120[gi_152 - l_index_28];
      g_ibuf_120[gi_152 - l_index_28] = ld_96;
   }
   for (l_index_28 = 1; l_index_28 <= gi_152 - 1; l_index_28++) {
      li_104 = 60 * Period();
      li_108 = Time[LastBar] + li_104 * l_index_28;
      li_unused_112 = 1000;
      li_116 = 0;
      ld_120 = g_ibuf_120[gi_152 - l_index_28] - (g_ibuf_120[gi_152 - l_index_28 + 1]);
      if (ld_120 > 0.0) li_116 = 255;
      else li_116 = 16711680;
      li_128 = 10;
      if (Symbol() == "GBPUSD") li_128 = 20;
      if (Symbol() == "USDJPY") li_128 = 20;
      if (Period() == PERIOD_M30) li_128 = 10;
      if (Period() == PERIOD_D1) li_128 = 40;
      ld_132 = MathRound((g_ibuf_120[gi_152 - l_index_28]) / (Point * li_128)) * (Point * li_128);
      DrawMarker(li_108, ld_132, li_116, "");
   }
   double ld_140 = MathRand();
   PastBars = 400.0 * (ld_140 / 32767.001) + 70.0;
   ld_140 = MathRand();
   HarmNo = 20.0 * (ld_140 / 32767.001) + 10.0;
   return (0);
}

void Freq(double &ad_0, double &ad_8, double &ad_16, double &ad_24) {
   double lda_32[];
   double ld_36;
   double ld_44;
   ArrayResize(lda_32, gi_148);
   double ld_52 = 0.0;
   double ld_60 = 2.0;
   lda_32[0] = Open[gi_156] - g_ibuf_116[0];
   while (MathAbs(ld_52 - ld_60) > FreqTOL) {
      ld_52 = ld_60;
      lda_32[1] = Open[gi_156 + 1] - g_ibuf_116[1] + ld_52 * lda_32[0];
      ld_36 = lda_32[0] * lda_32[1];
      ld_44 = lda_32[0] * lda_32[0];
      for (int li_68 = 2; li_68 < gi_148; li_68++) {
         lda_32[li_68] = Open[li_68 + gi_156] - g_ibuf_116[li_68] + ld_52 * (lda_32[li_68 - 1]) - (lda_32[li_68 - 2]);
         ld_36 += (lda_32[li_68 - 1]) * (lda_32[li_68] + (lda_32[li_68 - 2]));
         ld_44 += (lda_32[li_68 - 1]) * (lda_32[li_68 - 1]);
      }
      ld_60 = ld_36 / ld_44;
   }
   ad_0 = MathArccos(ld_60 / 2.0);
   Fit(ad_0, ad_8, ad_16, ad_24);
}

void Fit(double ad_0, double &ad_8, double &ad_16, double &ad_24) {
   double ld_108;
   double ld_116;
   double ld_32 = 0.0;
   double ld_40 = 0.0;
   double ld_48 = 0.0;
   double ld_56 = 0.0;
   double ld_64 = 0.0;
   double ld_72 = 0.0;
   double ld_80 = 0.0;
   double ld_88 = 0.0;
   double ld_96 = 0.0;
   for (int l_index_104 = 0; l_index_104 < gi_148; l_index_104++) {
      ld_108 = MathCos(ad_0 * l_index_104);
      ld_116 = MathSin(ad_0 * l_index_104);
      ld_32 += ld_108;
      ld_40 += ld_116;
      ld_48 += ld_108 * ld_108;
      ld_56 += ld_116 * ld_116;
      ld_64 += ld_108 * ld_116;
      ld_72 += Open[l_index_104 + gi_156] - g_ibuf_116[l_index_104];
      ld_80 += MathPow(Open[l_index_104 + gi_156] - g_ibuf_116[l_index_104], 2);
      ld_88 += (Open[l_index_104 + gi_156] - g_ibuf_116[l_index_104]) * ld_108;
      ld_96 += (Open[l_index_104 + gi_156] - g_ibuf_116[l_index_104]) * ld_116;
   }
   ld_32 /= gi_148;
   ld_40 /= gi_148;
   ld_48 /= gi_148;
   ld_56 /= gi_148;
   ld_64 /= gi_148;
   ld_72 /= gi_148;
   ld_80 /= gi_148;
   ld_88 /= gi_148;
   ld_96 /= gi_148;
   if (ad_0 == 0.0) {
      ad_8 = ld_72;
      ad_16 = 0.0;
      ad_24 = 0.0;
      return;
   }
   double ld_124 = MathPow(ld_64 - ld_32 * ld_40, 2) - (ld_48 - ld_32 * ld_32) * (ld_56 - ld_40 * ld_40);
   ad_16 = ((ld_96 - ld_72 * ld_40) * (ld_64 - ld_32 * ld_40) - (ld_88 - ld_72 * ld_32) * (ld_56 - ld_40 * ld_40)) / ld_124;
   ad_24 = ((ld_88 - ld_72 * ld_32) * (ld_64 - ld_32 * ld_40) - (ld_96 - ld_72 * ld_40) * (ld_48 - ld_32 * ld_32)) / ld_124;
   ad_8 = ld_72 - ad_16 * ld_32 - ad_24 * ld_40;
}

void ACF(double ada_0[], int ai_4, double &ada_8[]) {
   double lda_16[];
   double ld_20;
   double ld_36;
   int li_56;
   int li_60;
   int l_arr_size_12 = ArraySize(ada_0);
   ArrayResize(lda_16, ai_4 + 1);
   for (int l_index_48 = 0; l_index_48 <= ai_4; l_index_48++) {
      lda_16[l_index_48] = 0.0;
      for (int li_44 = l_index_48; li_44 < l_arr_size_12; li_44++) lda_16[l_index_48] += ada_0[li_44] * (ada_0[li_44 - l_index_48]);
   }
   double ld_28 = lda_16[0];
   for (int li_52 = 1; li_52 <= ai_4; li_52++) {
      ld_20 = -lda_16[li_52];
      for (li_44 = 1; li_44 < li_52; li_44++) ld_20 -= ada_8[li_44] * (lda_16[li_52 - li_44]);
      ld_20 /= ld_28;
      ada_8[li_52] = ld_20;
      li_56 = li_52 / 2;
      for (li_44 = 1; li_44 <= li_56; li_44++) {
         li_60 = li_52 - li_44;
         ld_36 = ada_8[li_44];
         ada_8[li_44] += ld_20 * ada_8[li_60];
         if (li_44 != li_60) ada_8[li_60] += ld_20 * ld_36;
      }
      ld_28 *= (1 - ld_20 * ld_20);
   }
}

void WBurg(double ada_0[], int ai_4, int ai_8, double &ada_12[]) {
   double lda_20[];
   double lda_24[];
   int li_36;
   int li_40;
   double ld_44;
   double ld_52;
   double ld_60;
   double ld_68;
   int l_arr_size_16 = ArraySize(ada_0);
   ArrayResize(lda_20, l_arr_size_16);
   ArrayResize(lda_24, l_arr_size_16);
   for (int l_index_28 = 0; l_index_28 < l_arr_size_16; l_index_28++) {
      lda_20[l_index_28] = ada_0[l_index_28];
      lda_24[l_index_28] = ada_0[l_index_28];
   }
   for (int li_32 = 1; li_32 <= ai_4; li_32++) {
      ld_52 = 0.0;
      ld_60 = 0.0;
      if (li_32 == 1) {
         for (l_index_28 = 2; l_index_28 < l_arr_size_16; l_index_28++) {
            ld_52 += win(l_index_28, 2, l_arr_size_16, ai_8) * (ada_0[l_index_28 - 1]) * (ada_0[l_index_28] + (ada_0[l_index_28 - 2]));
            ld_60 += win(l_index_28, 2, l_arr_size_16, ai_8) * (ada_0[l_index_28 - 1]) * (ada_0[l_index_28 - 1]);
         }
         ld_68 = (-ld_52) / ld_60 / 2.0;
         if (ld_68 > 1.0) ld_68 = 1.0;
         if (ld_68 < -1.0) ld_68 = -1.0;
      } else {
         for (l_index_28 = li_32; l_index_28 < l_arr_size_16; l_index_28++) {
            ld_52 += win(l_index_28, li_32, l_arr_size_16, ai_8) * lda_20[l_index_28] * (lda_24[l_index_28 - 1]);
            ld_60 += win(l_index_28, li_32, l_arr_size_16, ai_8) * (lda_20[l_index_28] * lda_20[l_index_28] + (lda_24[l_index_28 - 1]) * (lda_24[l_index_28 - 1]));
         }
         ld_68 = (-2.0 * ld_52) / ld_60;
      }
      ada_12[li_32] = ld_68;
      li_36 = li_32 / 2;
      for (l_index_28 = 1; l_index_28 <= li_36; l_index_28++) {
         li_40 = li_32 - l_index_28;
         ld_44 = ada_12[l_index_28];
         ada_12[l_index_28] += ld_68 * ada_12[li_40];
         if (l_index_28 != li_40) ada_12[li_40] += ld_68 * ld_44;
      }
      if (li_32 < ai_4) {
         for (l_index_28 = l_arr_size_16 - 1; l_index_28 >= li_32; l_index_28--) {
            ld_44 = lda_20[l_index_28];
            lda_20[l_index_28] += ld_68 * (lda_24[l_index_28 - 1]);
            lda_24[l_index_28] = lda_24[l_index_28 - 1] + ld_68 * ld_44;
         }
      }
   }
}

double win(int ai_0, int ai_4, int ai_8, int ai_12) {
   if (ai_12 == 0) return (1.0);
   if (ai_12 == 1) return (0.54 - MathCos(3.1415926536 * (2.0 * (ai_0 - ai_4) + 1.0) / (ai_8 - ai_4)) / 2.0);
   if (ai_12 == 2) return (6.0 * (ai_0 - ai_4 + 1.0) * (ai_8 - ai_0) / (ai_8 - ai_4) / (ai_8 - ai_4 + 1.0) / (ai_8 - ai_4 + 2.0));
   return (0.0);
}

void HNBurg(double ada_0[], int ai_4, double &ada_8[]) {
   double lda_16[];
   double lda_20[];
   int li_32;
   int li_36;
   double ld_40;
   double ld_48;
   double ld_56;
   double ld_64;
   double ld_72;
   int l_arr_size_12 = ArraySize(ada_0);
   ArrayResize(lda_16, l_arr_size_12);
   ArrayResize(lda_20, l_arr_size_12);
   for (int l_index_24 = 0; l_index_24 < l_arr_size_12; l_index_24++) {
      lda_16[l_index_24] = ada_0[l_index_24];
      lda_20[l_index_24] = ada_0[l_index_24];
   }
   for (int li_28 = 1; li_28 <= ai_4; li_28++) {
      ld_56 = 0.0;
      ld_64 = 0.0;
      if (li_28 == 1) {
         for (l_index_24 = 2; l_index_24 < l_arr_size_12; l_index_24++) {
            ld_40 = (ada_0[l_index_24 - 1]) * (ada_0[l_index_24 - 1]);
            ld_56 += ld_40 * (ada_0[l_index_24 - 1]) * (ada_0[l_index_24] + (ada_0[l_index_24 - 2]));
            ld_64 += ld_40 * (ada_0[l_index_24 - 1]) * (ada_0[l_index_24 - 1]);
         }
         ld_72 = (-ld_56) / ld_64 / 2.0;
         if (ld_72 > 1.0) ld_72 = 1.0;
         if (ld_72 < -1.0) ld_72 = -1.0;
      } else {
         ld_40 = 0.0;
         for (l_index_24 = 1; l_index_24 < li_28; l_index_24++) ld_40 += ada_0[l_index_24] * ada_0[l_index_24];
         for (l_index_24 = li_28; l_index_24 < l_arr_size_12; l_index_24++) {
            ld_56 += ld_40 * lda_16[l_index_24] * (lda_20[l_index_24 - 1]);
            ld_64 += ld_40 * (lda_16[l_index_24] * lda_16[l_index_24] + (lda_20[l_index_24 - 1]) * (lda_20[l_index_24 - 1]));
            ld_40 = ld_40 + ada_0[l_index_24] * ada_0[l_index_24] - (ada_0[l_index_24 - li_28 + 1]) * (ada_0[l_index_24 - li_28 + 1]);
         }
         ld_72 = (-2.0 * ld_56) / ld_64;
      }
      ada_8[li_28] = ld_72;
      li_32 = li_28 / 2;
      for (l_index_24 = 1; l_index_24 <= li_32; l_index_24++) {
         li_36 = li_28 - l_index_24;
         ld_48 = ada_8[l_index_24];
         ada_8[l_index_24] += ld_72 * ada_8[li_36];
         if (l_index_24 != li_36) ada_8[li_36] += ld_72 * ld_48;
      }
      if (li_28 < ai_4) {
         for (l_index_24 = l_arr_size_12 - 1; l_index_24 >= li_28; l_index_24--) {
            ld_48 = lda_16[l_index_24];
            lda_16[l_index_24] += ld_72 * (lda_20[l_index_24 - 1]);
            lda_20[l_index_24] = lda_20[l_index_24 - 1] + ld_72 * ld_48;
         }
      }
   }
}

void Geom(double ada_0[], int ai_4, double &ada_8[]) {
   double lda_16[];
   double lda_20[];
   int li_32;
   int li_36;
   double ld_40;
   double ld_48;
   double ld_56;
   double ld_64;
   double ld_72;
   int l_arr_size_12 = ArraySize(ada_0);
   ArrayResize(lda_16, l_arr_size_12);
   ArrayResize(lda_20, l_arr_size_12);
   for (int l_index_24 = 0; l_index_24 < l_arr_size_12; l_index_24++) {
      lda_16[l_index_24] = ada_0[l_index_24];
      lda_20[l_index_24] = ada_0[l_index_24];
   }
   for (int li_28 = 1; li_28 <= ai_4; li_28++) {
      ld_48 = 0.0;
      ld_56 = 0.0;
      ld_64 = 0.0;
      for (l_index_24 = li_28; l_index_24 < l_arr_size_12; l_index_24++) {
         ld_48 += lda_16[l_index_24] * (lda_20[l_index_24 - 1]);
         ld_56 += lda_16[l_index_24] * lda_16[l_index_24];
         ld_64 += (lda_20[l_index_24 - 1]) * (lda_20[l_index_24 - 1]);
      }
      ld_72 = (-ld_48) / MathSqrt(ld_56) / MathSqrt(ld_64);
      ada_8[li_28] = ld_72;
      li_32 = li_28 / 2;
      for (l_index_24 = 1; l_index_24 <= li_32; l_index_24++) {
         li_36 = li_28 - l_index_24;
         ld_40 = ada_8[l_index_24];
         ada_8[l_index_24] += ld_72 * ada_8[li_36];
         if (l_index_24 != li_36) ada_8[li_36] += ld_72 * ld_40;
      }
      if (li_28 < ai_4) {
         for (l_index_24 = l_arr_size_12 - 1; l_index_24 >= li_28; l_index_24--) {
            ld_40 = lda_16[l_index_24];
            lda_16[l_index_24] += ld_72 * (lda_20[l_index_24 - 1]);
            lda_20[l_index_24] = lda_20[l_index_24 - 1] + ld_72 * ld_40;
         }
      }
   }
}

void MCov(double ada_0[], int ai_4, double &ada_8[], int &ai_12) {
   double lda_20[];
   double lda_24[];
   double lda_28[];
   int li_48;
   double ld_84;
   double ld_116;
   double ld_124;
   double ld_132;
   double ld_140;
   double ld_148;
   double ld_156;
   double ld_164;
   double ld_172;
   double ld_180;
   double ld_188;
   double ld_196;
   double ld_204;
   double ld_212;
   int l_arr_size_16 = ArraySize(ada_0);
   ArrayResize(lda_20, ai_4 + 1);
   ArrayResize(lda_24, ai_4 + 1);
   ArrayResize(lda_28, ai_4);
   double ld_52 = 0.0;
   for (int l_index_40 = 1; l_index_40 < l_arr_size_16 - 1; l_index_40++) ld_52 += 2.0 * ada_0[l_index_40] * ada_0[l_index_40];
   double ld_60 = (ada_0[l_arr_size_16 - 1]) * (ada_0[l_arr_size_16 - 1]);
   double ld_68 = ada_0[0] * ada_0[0];
   double ld_76 = 1.0 / (ld_52 + 2.0 * (ld_60 + ld_68));
   double ld_32 = ld_52 + ld_60 + ld_68;
   double ld_92 = 1.0 - ld_60 * ld_76;
   double ld_100 = 1.0 - ld_68 * ld_76;
   double ld_108 = ada_0[0] * (ada_0[l_arr_size_16 - 1]) * ld_76;
   lda_20[0] = ada_0[0] * ld_76;
   lda_24[0] = (ada_0[l_arr_size_16 - 1]) * ld_76;
   int l_index_44 = 0;
   while (true) {
      ld_140 = 0.0;
      for (l_index_40 = l_index_44 + 1; l_index_40 < l_arr_size_16; l_index_40++) ld_140 += (ada_0[l_arr_size_16 - 1 - l_index_40]) * (ada_0[l_arr_size_16 - l_index_40 + l_index_44]);
      ld_140 = 2.0 * ld_140;
      lda_28[l_index_44] = ld_140;
      ld_116 = ada_0[0] * lda_24[0];
      ld_124 = ada_0[0] * lda_20[0];
      ld_132 = (ada_0[l_arr_size_16 - 1]) * lda_24[0];
      if (l_index_44 > 0) {
         for (l_index_40 = 1; l_index_40 <= l_index_44; l_index_40++) {
            ld_116 += ada_0[l_index_40] * lda_24[l_index_40];
            ld_124 += ada_0[l_index_40] * lda_20[l_index_40];
            ld_132 += (ada_0[l_arr_size_16 - 1 - l_index_40]) * lda_24[l_index_40];
            lda_28[l_index_40 - 1] = lda_28[l_index_40 - 1] - (ada_0[l_index_44] * (ada_0[l_index_44 - l_index_40]) + (ada_0[l_arr_size_16 - 1 - l_index_44]) * (ada_0[l_arr_size_16 - 1 - l_index_44 +
               l_index_40]));
            ld_140 += (lda_28[l_index_40 - 1]) * (ada_8[l_index_44 - l_index_40]);
         }
      }
      ld_172 = (-ld_140) / ld_32;
      ada_8[l_index_44] = ld_172;
      ld_32 *= (1.0 - ld_172 * ld_172);
      if (l_index_44 > 0) {
         for (l_index_40 = 0; l_index_40 < (l_index_44 + 1) / 2; l_index_40++) {
            li_48 = l_index_44 - l_index_40 - 1;
            ld_140 = ada_8[l_index_40];
            ada_8[l_index_40] = ld_140 + ld_172 * ada_8[li_48];
            if (l_index_40 != li_48) ada_8[li_48] += ld_172 * ld_140;
         }
      }
      if (l_index_44 == ai_4 - 1) {
         ld_32 *= 0.5 / (l_arr_size_16 - 1 - l_index_44);
         return;
      }
      ld_52 = 1.0 / (ld_92 * ld_100 - ld_108 * ld_108);
      ld_172 = (ld_116 * ld_108 + ld_124 * ld_92) * ld_52;
      ld_180 = (ld_124 * ld_108 + ld_116 * ld_100) * ld_52;
      ld_188 = (ld_132 * ld_108 + ld_116 * ld_92) * ld_52;
      ld_196 = (ld_116 * ld_108 + ld_132 * ld_100) * ld_52;
      for (l_index_40 = 0; l_index_40 <= l_index_44 / 2; l_index_40++) {
         li_48 = l_index_44 - l_index_40;
         ld_140 = lda_20[l_index_40];
         ld_148 = lda_24[l_index_40];
         ld_156 = lda_20[li_48];
         ld_164 = lda_24[li_48];
         lda_20[l_index_40] += (ld_172 * ld_156 + ld_180 * ld_164);
         lda_24[l_index_40] += (ld_188 * ld_156 + ld_196 * ld_164);
         if (l_index_40 != li_48) {
            lda_20[li_48] += (ld_172 * ld_140 + ld_180 * ld_148);
            lda_24[li_48] += (ld_188 * ld_140 + ld_196 * ld_148);
         }
      }
      ld_60 = ld_124 * ld_124;
      ld_68 = ld_116 * ld_116;
      ld_76 = ld_132 * ld_132;
      ld_84 = ld_100 - (ld_60 * ld_92 + ld_68 * ld_100 + 2.0 * ld_124 * ld_108 * ld_116) * ld_52;
      ld_60 = ld_92 - (ld_68 * ld_92 + ld_76 * ld_100 + 2.0 * ld_116 * ld_108 * ld_132) * ld_52;
      ld_100 = ld_84;
      ld_92 = ld_60;
      ld_108 += ld_188 * ld_124 + ld_196 * ld_116;
      if (ld_32 <= 0.0) {
         Print("Error: negative or zero variance in MCov");
         ai_12 = 1;
         return;
      }
      if (ld_92 <= 0.0 || ld_92 > 1.0 || ld_100 <= 0.0 || ld_100 > 1.0) {
         Print("Error: delta and gamma are outside (0,1) in MCov");
         ai_12 = 1;
         return;
      }
      ld_52 = 1.0 / ld_32;
      ld_60 = 1.0 / (ld_92 * ld_100 - ld_108 * ld_108);
      ld_204 = ada_0[l_arr_size_16 - l_index_44 - 2];
      ld_212 = ada_0[l_index_44 + 1];
      for (l_index_40 = 0; l_index_40 <= l_index_44; l_index_40++) {
         ld_204 += ada_8[l_index_40] * (ada_0[l_arr_size_16 - 1 - l_index_44 + l_index_40]);
         ld_212 += ada_8[l_index_40] * (ada_0[l_index_44 - l_index_40]);
      }
      ld_172 = ld_212 * ld_52;
      ld_180 = ld_204 * ld_52;
      ld_188 = (ld_212 * ld_92 + ld_204 * ld_108) * ld_60;
      ld_196 = (ld_204 * ld_100 + ld_212 * ld_108) * ld_60;
      for (l_index_40 = l_index_44; l_index_40 >= 0; l_index_40--) {
         ld_140 = ada_8[l_index_40];
         ada_8[l_index_40] = ld_140 + ld_188 * lda_20[l_index_40] + ld_196 * lda_24[l_index_40];
         lda_20[l_index_40 + 1] = lda_20[l_index_40] + ld_172 * ld_140;
         lda_24[l_index_40 + 1] = lda_24[l_index_40] + ld_180 * ld_140;
      }
      lda_20[0] = ld_172;
      lda_24[0] = ld_180;
      ld_68 = ld_212 * ld_212;
      ld_76 = ld_204 * ld_204;
      ld_32 -= (ld_68 * ld_92 + ld_76 * ld_100 + 2.0 * ld_204 * ld_212 * ld_108) * ld_60;
      ld_92 -= ld_76 * ld_52;
      ld_100 -= ld_68 * ld_52;
      ld_108 += ld_204 * ld_212 * ld_52;
      if (ld_32 <= 0.0) {
         Print("Error: negative or zero variance in MCov");
         ai_12 = 1;
         return;
      }
      if (ld_92 <= 0.0 || ld_92 > 1.0 || ld_100 <= 0.0 || ld_100 > 1.0) {
         Print("Error: delta and gamma are outside (0,1) in MCov");
         ai_12 = 1;
         return;
      }
      l_index_44++;
   }
}

void DrawMarker(int a_datetime_0, double a_price_4, int ai_12, string as_unused_16) {
   int li_32;
   int li_36;
   int li_40;
   int li_44;
   color l_color_48;
   string l_name_24 = DoubleToStr(a_datetime_0, 0) + "_" + DoubleToStr(a_price_4, Digits);
   if (ObjectFind(l_name_24) == 0) {
      li_32 = ObjectGet(l_name_24, OBJPROP_COLOR);
      li_36 = GetRed(li_32);
      li_40 = GetBlue(li_32);
      li_44 = GetGreen(li_32);
      if (ai_12 == 255) l_color_48 = fromRGB(li_40 + 10, 0, li_36 - 10);
      if (ai_12 == 16711680) l_color_48 = fromRGB(li_40 - 10, 0, li_36 + 10);
      ObjectSet(l_name_24, OBJPROP_COLOR, l_color_48);
      li_36 = GetRed(l_color_48);
      li_40 = GetBlue(l_color_48);
      li_44 = GetGreen(l_color_48);
      if (li_36 > li_40) {
         if (li_36 > 200) ObjectSet(l_name_24, OBJPROP_ARROWCODE, 226);
         if (li_36 == 255) ObjectSet(l_name_24, OBJPROP_ARROWCODE, 234);
      }
      if (li_36 < li_40) {
         if (li_40 > 200) ObjectSet(l_name_24, OBJPROP_ARROWCODE, 225);
         if (li_40 == 255) ObjectSet(l_name_24, OBJPROP_ARROWCODE, 233);
      }
   } else {
      ObjectCreate(l_name_24, OBJ_ARROW, 0, a_datetime_0, a_price_4);
      ObjectSet(l_name_24, OBJPROP_ARROWCODE, 158);
      ObjectSet(l_name_24, OBJPROP_COLOR, fromRGB(128, 0, 128));
      ObjectSet(l_name_24, OBJPROP_WIDTH, 0);
   }
}

int fromRGB(int ai_0, int ai_4, int ai_8) {
   if (ai_0 > 255) ai_0 = 255;
   if (ai_4 > 255) ai_4 = 255;
   if (ai_8 > 255) ai_8 = 255;
   if (ai_0 < 1) ai_0 = 0;
   if (ai_4 < 1) ai_4 = 0;
   if (ai_8 < 1) ai_8 = 0;
   return (ai_0 + ai_4 << 8 + ai_8 << 16);
}

int GetRed(int ai_0) {
   int li_ret_4 = ai_0 >> 16 & 255;
   int li_8 = ai_0 >> 8 & 255;
   int li_12 = ai_0 & 255;
   return (li_ret_4);
}

int GetBlue(int ai_0) {
   int li_4 = ai_0 >> 16 & 255;
   int li_8 = ai_0 >> 8 & 255;
   int li_ret_12 = ai_0 & 255;
   return (li_ret_12);
}

int GetGreen(int ai_0) {
   int li_4 = ai_0 >> 16 & 255;
   int li_ret_8 = ai_0 >> 8 & 255;
   int li_12 = ai_0 & 255;
   return (li_ret_8);
}